package co.yixiang.yshop.module.distributor.service.distributoruser;

import java.util.*;
import javax.validation.*;

import co.yixiang.yshop.module.distributor.controller.admin.distributoruser.vo.*;
import co.yixiang.yshop.module.distributor.dal.dataobject.distributoruser.DistributorUserDO;
import co.yixiang.yshop.framework.common.pojo.PageResult;

/**
 * 分销商所属用户 Service 接口
 *
 * @author admin
 */
public interface DistributorUserService {

    /**
     * 创建分销商所属用户
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createUser(@Valid DistributorUserCreateReqVO createReqVO);

    /**
     * 更新分销商所属用户
     *
     * @param updateReqVO 更新信息
     */
    void updateUser(@Valid DistributorUserUpdateReqVO updateReqVO);

    /**
     * 删除分销商所属用户
     *
     * @param id 编号
     */
    void deleteUser(Long id);

    /**
     * 获得分销商所属用户
     *
     * @param id 编号
     * @return 分销商所属用户
     */
    DistributorUserDO getUser(Long id);

    /**
     * 获得分销商所属用户列表
     *
     * @param ids 编号
     * @return 分销商所属用户列表
     */
    List<DistributorUserDO> getUserList(Collection<Long> ids);

    /**
     * 获得分销商所属用户分页
     *
     * @param pageReqVO 分页查询
     * @return 分销商所属用户分页
     */
    PageResult<DistributorUserDO> getUserPage(DistributorUserPageReqVO pageReqVO);

    /**
     * 获得分销商所属用户列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 分销商所属用户列表
     */
    List<DistributorUserDO> getUserList(DistributorUserExportReqVO exportReqVO);

    void clearance(Long id);

    DistributorUserDO getByUserId(Long userId);
}

